/***
 *
 * GL Shader Tool - Convinient Basic Shader functionality
 *
 * Copyright (c) 2007, Sven Gothel
 * Copyright (c) 2007, MAME Team
 *
 * Dual license: MAME and GPL version 2
 *
 * This module has a dual license, i.e. it is compatible to MAME,
 * but I like to reserve my rights to use this module under 
 * the GPL as well.
 *
 * GPL license:
 *      Visit http://www.gnu.org/copyleft/gpl.html
 *
 * MAME license:
 *	Visit http://mamedev.org for licensing and usage restrictions.
 *
 *
 * OpenGL GLSL ARB extentions:
 *
 *	GL_ARB_shader_objects
 *	GL_ARB_shading_language_100
 *	GL_ARB_vertex_shader
 *	GL_ARB_fragment_shader
 *
 */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "gl_shader_tool.h"

PFNGLGETOBJECTPARAMETERIVARBPROC pfn_glGetObjectParameterivARB=NULL;
PFNGLGETINFOLOGARBPROC pfn_glGetInfoLogARB=NULL;
PFNGLDELETEOBJECTARBPROC pfn_glDeleteObjectARB=NULL;
PFNGLCREATESHADEROBJECTARBPROC pfn_glCreateShaderObjectARB=NULL;
PFNGLSHADERSOURCEARBPROC pfn_glShaderSourceARB=NULL;
PFNGLCOMPILESHADERARBPROC pfn_glCompileShaderARB=NULL;
PFNGLCREATEPROGRAMOBJECTARBPROC pfn_glCreateProgramObjectARB=NULL;
PFNGLATTACHOBJECTARBPROC pfn_glAttachObjectARB=NULL;
PFNGLLINKPROGRAMARBPROC pfn_glLinkProgramARB=NULL;
PFNGLVALIDATEPROGRAMARBPROC pfn_glValidateProgramARB=NULL;
PFNGLUSEPROGRAMOBJECTARBPROC pfn_glUseProgramObjectARB=NULL;
PFNGLGETUNIFORMLOCATIONARBPROC pfn_glGetUniformLocationARB=NULL;
PFNGLUNIFORM1FARBPROC pfn_glUniform1fARB=NULL;
PFNGLUNIFORM1IARBPROC pfn_glUniform1iARB=NULL;
PFNGLUNIFORM1FVARBPROC pfn_glUniform1fvARB=NULL;
PFNGLUNIFORM1IVARBPROC pfn_glUniform1ivARB=NULL;


int gl_shader_loadExtention(PFNGLGETPROCADDRESSOS GetProcAddress)
{
	pfn_glGetObjectParameterivARB = (PFNGLGETOBJECTPARAMETERIVARBPROC) GetProcAddress("glGetObjectParameterivARB");
	pfn_glGetInfoLogARB           = (PFNGLGETINFOLOGARBPROC) GetProcAddress ("glGetInfoLogARB");
	pfn_glDeleteObjectARB         = (PFNGLDELETEOBJECTARBPROC) GetProcAddress ("glDeleteObjectARB");
	pfn_glCreateShaderObjectARB   = (PFNGLCREATESHADEROBJECTARBPROC) GetProcAddress ("glCreateShaderObjectARB");
	pfn_glShaderSourceARB         = (PFNGLSHADERSOURCEARBPROC) GetProcAddress ("glShaderSourceARB");
	pfn_glCompileShaderARB        = (PFNGLCOMPILESHADERARBPROC) GetProcAddress ("glCompileShaderARB");
	pfn_glCreateProgramObjectARB  = (PFNGLCREATEPROGRAMOBJECTARBPROC) GetProcAddress ("glCreateProgramObjectARB");
	pfn_glAttachObjectARB         = (PFNGLATTACHOBJECTARBPROC) GetProcAddress ("glAttachObjectARB");
	pfn_glLinkProgramARB          = (PFNGLLINKPROGRAMARBPROC) GetProcAddress ("glLinkProgramARB");
	pfn_glValidateProgramARB      = (PFNGLVALIDATEPROGRAMARBPROC) GetProcAddress ("glValidateProgramARB");
	pfn_glUseProgramObjectARB     = (PFNGLUSEPROGRAMOBJECTARBPROC) GetProcAddress ("glUseProgramObjectARB");
	pfn_glGetUniformLocationARB   = (PFNGLGETUNIFORMLOCATIONARBPROC) GetProcAddress ("glGetUniformLocationARB");
	pfn_glUniform1fARB            = (PFNGLUNIFORM1FARBPROC) GetProcAddress ("glUniform1fARB");
	pfn_glUniform1iARB            = (PFNGLUNIFORM1IARBPROC) GetProcAddress ("glUniform1iARB");
	pfn_glUniform1fvARB           = (PFNGLUNIFORM1FVARBPROC) GetProcAddress ("glUniform1fvARB");
	pfn_glUniform1ivARB           = (PFNGLUNIFORM1IVARBPROC) GetProcAddress ("glUniform1ivARB");

	if ( pfn_glGetObjectParameterivARB && pfn_glGetInfoLogARB && pfn_glDeleteObjectARB && pfn_glCreateShaderObjectARB &&
	     pfn_glShaderSourceARB && pfn_glCompileShaderARB && pfn_glCreateProgramObjectARB && pfn_glAttachObjectARB &&
	     pfn_glLinkProgramARB && pfn_glValidateProgramARB && pfn_glUseProgramObjectARB && pfn_glGetUniformLocationARB &&
	     pfn_glGetUniformLocationARB && pfn_glUniform1fARB && pfn_glUniform1iARB && 
	     pfn_glUniform1fvARB && pfn_glUniform1ivARB
	   )
	{
		return 0;
	}

	printf("OpenGL: missing ARB shader function: ");
	if (!pfn_glGetObjectParameterivARB) printf("glGetObjectParameterivARB, ");
	if (!pfn_glGetInfoLogARB) printf("glGetInfoLogARB, ");
	if (!pfn_glDeleteObjectARB) printf("glDeleteObjectARB, ");
	if (!pfn_glCreateShaderObjectARB) printf("glCreateShaderObjectARB, ");
	if (!pfn_glShaderSourceARB) printf("glShaderSourceARB, ");
	if (!pfn_glCompileShaderARB) printf("glCompileShaderARB, ");
	if (!pfn_glCreateProgramObjectARB) printf("glCreateProgramObjectARB, ");
	if (!pfn_glAttachObjectARB) printf("glAttachObjectARB, ");
	if (!pfn_glLinkProgramARB) printf("glLinkProgramARB, ");
	if (!pfn_glValidateProgramARB) printf("glValidateProgramARB, ");
	if (!pfn_glUseProgramObjectARB) printf("glUseProgramObjectARB, ");
	if (!pfn_glGetUniformLocationARB) printf("glGetUniformLocationARB, ");
	if (!pfn_glUniform1fARB) printf("glUniform1fARB, ");
	if (!pfn_glUniform1iARB) printf("glUniform1iARB");
	if (!pfn_glUniform1fvARB) printf("glUniform1fvARB, ");
	if (!pfn_glUniform1ivARB) printf("glUniform1ivARB");
	printf("\n");

	return -1;
}

int gl_check_error(GLSLCheckMode m, const char *file, const int line)
{
        GLenum glerr = glGetError();

        if (GL_NO_ERROR != glerr)
        {
                if ( CHECK_VERBOSE <= m )
                {
			fprintf(stderr, "%s:%d: GL Error: %d 0x%X\n", file, line, glerr, glerr);
                }
        }
	return (GL_NO_ERROR != glerr)? glerr : 0;
}

int gl_shader_check_error(GLhandleARB obj, GLenum obj_query, GLSLCheckMode m, const char *file, const int line)
{
        GLsizei length;
        GLcharARB buffer[255];
        GLenum glerr;
	GLint  param;
	int    res=0;

        glerr = gl_check_error(m, file, line);

	if(!obj)
		return glerr;

	if(obj_query != GL_OBJECT_TYPE_ARB            &&
	   obj_query != GL_OBJECT_DELETE_STATUS_ARB   &&
	   obj_query != GL_OBJECT_COMPILE_STATUS_ARB  &&
	   obj_query != GL_OBJECT_LINK_STATUS_ARB     &&
	   obj_query != GL_OBJECT_VALIDATE_STATUS_ARB
	  )
	{
		fprintf(stderr, "%s:%d: GL Error: gl_shader_check_error unsupported object query 0x%X\n", file, line, obj_query);
		return -1;
	}

	pfn_glGetObjectParameterivARB(obj, obj_query, &param);

	switch(obj_query)
	{
	  case GL_OBJECT_TYPE_ARB:
		if( param!=GL_PROGRAM_OBJECT_ARB && param!=GL_SHADER_OBJECT_ARB )
		{
			if ( CHECK_VERBOSE <= m )
				fprintf(stderr, "%s:%d: GL Error: object type 0x%X generation failed\n", file, line, obj);
			res=-1;
		} else if ( CHECK_ALWAYS_VERBOSE <= m ) 
		{
			if(param==GL_PROGRAM_OBJECT_ARB)
				fprintf(stderr, "%s:%d: GL Error: object type 0x%X is PROGRAM, successful\n", file, line, obj);
			else
				fprintf(stderr, "%s:%d: GL Info: object type 0x%X is SHADER, successful\n", file, line, obj);
		}
		break;
	  case GL_OBJECT_DELETE_STATUS_ARB:
		if(param!=1)
		{
			if ( CHECK_VERBOSE <= m )
				fprintf(stderr, "%s:%d: GL Error: object 0x%X deletion failed\n", file, line, obj);
			res=-1;
		} else if ( CHECK_ALWAYS_VERBOSE <= m ) 
		{
			fprintf(stderr, "%s:%d: GL Info: object 0x%X deletion successful\n", file, line, obj);
		}
		break;
	  case GL_OBJECT_COMPILE_STATUS_ARB:
		if(param!=1)
		{
			if ( CHECK_VERBOSE <= m )
				fprintf(stderr, "%s:%d: GL Error: object 0x%X compilation failed\n", file, line, obj);
			res=-1;
		} else if ( CHECK_ALWAYS_VERBOSE <= m ) 
		{
			fprintf(stderr, "%s:%d: GL Info: object 0x%X compiled successful\n", file, line, obj);
		}
		break;
	  case GL_OBJECT_LINK_STATUS_ARB:
		if(param!=1)
		{
			if ( CHECK_VERBOSE <= m )
				fprintf(stderr, "%s:%d: GL Error: object 0x%X linking failed\n", file, line, obj);
			res=-1;
		} else if ( CHECK_ALWAYS_VERBOSE <= m ) 
		{
			fprintf(stderr, "%s:%d: GL Info: object 0x%X linked successful\n", file, line, obj);
		}
		break;
	  case GL_OBJECT_VALIDATE_STATUS_ARB:
		if(param!=1)
		{
			if ( CHECK_VERBOSE <= m )
				fprintf(stderr, "%s:%d: GL Error: object 0x%X validation failed\n", file, line, obj);
			res=-1;
		} else if ( CHECK_ALWAYS_VERBOSE <= m ) 
		{
			fprintf(stderr, "%s:%d: GL Info: object 0x%X validation successful\n", file, line, obj);
		}
		break;
	 }

	if ( res<0 || CHECK_ALWAYS_VERBOSE <= m )
	{
		length=0;
		pfn_glGetInfoLogARB(obj, sizeof(buffer), &length, buffer);
		if(length>0)
			fprintf(stderr, "%s:%d glInfoLog: %s\n", file, line, buffer);
	}

	(void) glGetError(); // ;-)


	return res;
}

static int delete_shader_tool( GLhandleARB *program, GLhandleARB *vertex_shader, GLhandleARB *fragment_shader, int externalcall)
{
	int res=0;

	if(*program!=0)
	{
		pfn_glDeleteObjectARB(*program);
		if(externalcall)
		{
			res |= GL_SHADER_CHECK(*program, GL_OBJECT_DELETE_STATUS_ARB);
		}
	}
	if(*vertex_shader!=0)
	{
		pfn_glDeleteObjectARB(*vertex_shader);
		if(externalcall)
		{
			res |= GL_SHADER_CHECK(*vertex_shader, GL_OBJECT_DELETE_STATUS_ARB);
		}
	}
	if(*fragment_shader!=0)
	{
		pfn_glDeleteObjectARB(*fragment_shader);
		if(externalcall)
		{
			res |= GL_SHADER_CHECK(*fragment_shader, GL_OBJECT_DELETE_STATUS_ARB);
		}
	}

        *program=0;
        *vertex_shader=0;
        *fragment_shader=0;

        return 0;
}
	
int gl_compile_shaderfile( GLhandleARB *shader, GLenum type, const char * shader_file, int verbose )
{
        int err = 0, i, c;
	FILE * file = NULL;
	int buffer_len=4096;
	GLcharARB *buffer=NULL;

	file = fopen(shader_file, "r");
	if(!file)
	{
		fprintf(stderr, "cannot open shader_file: %s\n", shader_file);
		return -1;
	}

	buffer=calloc(buffer_len, 1);

        /* Load Shader Sources */
	i=0;
	while( i<buffer_len-1 && EOF!=(c=fgetc(file)) )
		buffer[i++]=(char)c;
	fclose(file);
	buffer[i]='\0';
	if(verbose)
		fprintf(stderr, "<%s>\n", buffer);

        *shader = pfn_glCreateShaderObjectARB(type);
	err=GL_SHADER_CHECK(*shader, GL_OBJECT_TYPE_ARB);
        if(err) goto errout;

        pfn_glShaderSourceARB(*shader, 1, (const GLcharARB **)&buffer, NULL);

        pfn_glCompileShaderARB(*shader);
        err=GL_SHADER_CHECK(*shader, GL_OBJECT_COMPILE_STATUS_ARB);
        if(err) goto errout;

	free(buffer);
	return 0;

errout:
	free(buffer);
	if(*shader!=0)
	{
		pfn_glDeleteObjectARB(*shader);
	}
	fprintf(stderr, "failed to process shader_file: %s\n", shader_file);
        return err;
}

int gl_compile_shaderfiles( GLhandleARB *program, GLhandleARB *vertex_shader, GLhandleARB *fragment_shader,
                            const char * vertex_shader_file,
                            const char * fragment_shader_file,
			    int verbose
                          )
{
	int err;

        *program = pfn_glCreateProgramObjectARB();
        err=GL_SHADER_CHECK(*program, GL_OBJECT_TYPE_ARB);
        if(err) goto errout;

	err = gl_compile_shaderfile(vertex_shader, GL_VERTEX_SHADER_ARB, vertex_shader_file, verbose);
	if(err) return err;
	err = gl_compile_shaderfile(fragment_shader, GL_FRAGMENT_SHADER_ARB, fragment_shader_file, verbose);
	if(err) return err;

        pfn_glAttachObjectARB(*program, *vertex_shader);
        pfn_glAttachObjectARB(*program, *fragment_shader);

        pfn_glLinkProgramARB(*program);
        err=GL_SHADER_CHECK(*program, GL_OBJECT_LINK_STATUS_ARB);
        if(err) goto errout;

        pfn_glValidateProgramARB(*program);
        err=GL_SHADER_CHECK(*program, GL_OBJECT_VALIDATE_STATUS_ARB);
        if(err) goto errout;

        return 0;

errout:
        delete_shader_tool(program, vertex_shader, fragment_shader, 0);
        return err;

}

int gl_compile_shader( GLhandleARB *program, GLhandleARB *vertex_shader, GLhandleARB *fragment_shader,
                       const GLcharARB * vertex_shader_source,
                       const GLcharARB * fragment_shader_source
                     )
{
        int err = 0;

        *program = pfn_glCreateProgramObjectARB();
        err=GL_SHADER_CHECK(*program, GL_OBJECT_TYPE_ARB);
        if(err) goto errout;

        *vertex_shader = pfn_glCreateShaderObjectARB(GL_VERTEX_SHADER_ARB);
	err=GL_SHADER_CHECK(*vertex_shader, GL_OBJECT_TYPE_ARB);
        if(err) goto errout;

        *fragment_shader = pfn_glCreateShaderObjectARB(GL_FRAGMENT_SHADER_ARB);
	err=GL_SHADER_CHECK(*fragment_shader, GL_OBJECT_TYPE_ARB);
        if(err) goto errout;

        pfn_glShaderSourceARB(*vertex_shader, 1, &vertex_shader_source, NULL);
        pfn_glShaderSourceARB(*fragment_shader, 1, &fragment_shader_source, NULL);

        pfn_glCompileShaderARB(*vertex_shader);
        err=GL_SHADER_CHECK(*vertex_shader, GL_OBJECT_COMPILE_STATUS_ARB);
        if(err) {
		fprintf(stderr, "failed to compile vertex shader: <%s>\n", vertex_shader_source);
		goto errout;
	}

        pfn_glCompileShaderARB(*fragment_shader);
        err=GL_SHADER_CHECK(*fragment_shader, GL_OBJECT_COMPILE_STATUS_ARB);
        if(err) {
		fprintf(stderr, "failed to compile fragment shader: <%s>\n", fragment_shader_source);
		goto errout;
	}

        pfn_glAttachObjectARB(*program, *vertex_shader);
        pfn_glAttachObjectARB(*program, *fragment_shader);

        pfn_glLinkProgramARB(*program);
        err=GL_SHADER_CHECK(*program, GL_OBJECT_LINK_STATUS_ARB);
        if(err) {
		fprintf(stderr, "failed to link program\n");
		fprintf(stderr, "vertex shader: <%s>\n", vertex_shader_source);
		fprintf(stderr, "fragment shader: <%s>\n", fragment_shader_source);
		goto errout;
	}

        pfn_glValidateProgramARB(*program);
        err=GL_SHADER_CHECK(*program, GL_OBJECT_VALIDATE_STATUS_ARB);
        if(err) {
		fprintf(stderr, "failed to validate program\n");
		fprintf(stderr, "vertex shader: <%s>\n", vertex_shader_source);
		fprintf(stderr, "fragment shader: <%s>\n", fragment_shader_source);
		goto errout;
	}

        return 0;

errout:
        delete_shader_tool(program, vertex_shader, fragment_shader, 0);
        return err;

}


int gl_delete_shader( GLhandleARB *program, GLhandleARB *vertex_shader, GLhandleARB *fragment_shader )
{
	return delete_shader_tool(program, vertex_shader, fragment_shader, 1);
}


