/* This code was created by Jeff Molofee '99 (Ported to Linux/GLX by
 * Patrick Schubert 2000 with the help from lesson 1 basecode for Linux/GLX
 * by Mihael Vrbanec).
 *
 * Cleaned up and Hopefully easier to read version by Jason Schultz (2004)
 *
 * @File:			glx_base.h
 *
 * @Description: 	Main Header File for OpenGL/GLX Base code
 */
 
#ifndef _GLX_BASE_H_
#define _GLX_BASE_H_
 
/* Standard OpenGL/GLX header files */
#include <GL/glx.h>
#include <GL/gl.h>
/* Headers needed for keys used in the program */
#include <X11/extensions/xf86vmode.h>
#include <X11/keysym.h>
/* Standard C header files */
#include <stdio.h>
#include <stdlib.h>
#include <math.h> 
#include <time.h>
 
/* Define our window structure here
 *
 * Description of Structure Members:
 *
 * Display 				*dpy: 	This is the display. In X Windows, a display considers
 *								everything. Monitor, Mouse, Keyboard.
 * int	  				screen:	Which window we are rendering too ?
 * Window 				win:	This is our drawable surrface
 * GLXContext 			ctx:	Stores information about our OpenGL Context
 * XSetWindowAttributes attr:
 * BOOL					fs:		This is the fullscreen flag. Weither or not we have a fullscreen
 *								or not. 
 * XF86VidModeModeInfo 	deskmode:
 * int					x,y:
 * unsigned int			width:	Width of the window
 * unsigned int			height:	Height of the window
 * unsigned int 		bpp:	Bits Per Pixel. With XFree86, highest we can acheive is 24.	
 */
typedef struct
{
	Display 				*dpy;
	int						screen;
	Window					win;
	GLXContext				ctx;
	XSetWindowAttributes	attr;
	BOOL					fs;
	XF86VidModeModeInfo		deskMode;
	int						x,y;
	unsigned int			width, height;
	unsigned int			bpp;
}GLWindow;

extern GLWindow GLWin;	/* Set our OpenGL Window to static, we only want one */

/* Function Definitions */
 
void createGLWindow(const char* title, int width, int height, int bpp, BOOL fsflag);
void runGLScene(void);
void killGLWindow(void);
void resizeGLScene(void);
void swapBuffers(void);
void initKeys(void);
void updateGLScene(void);
BOOL initGLScene(void);
void cleanGLScene(void);
void drawGLScene(void);
 
 
#endif /* End of _GLX_BASE_H_ */
