
uniform float     my_brightness;
uniform sampler2D my_color_texture;      // = 0
uniform sampler2D my_colortable_texture; // = 1
varying vec2      texture_coordinate;

void main()
{
	float scale = 256.0/1024.0 ;
	vec4 color_tex;
	vec2 color_map_coord;
	vec4 color_map_val;
	float i=1.0;

	// Sampling The Texture And Passing It To The Frame Buffer
	color_tex = texture2D(my_color_texture, texture_coordinate) * scale ; // lookup space

	color_map_val = vec4(0.0, 0.0, 0.0, 1.0);

	color_map_coord = vec2(color_tex.b + i * scale, 0);
	color_map_val.b = texture2D(my_colortable_texture, color_map_coord).r;

	color_map_coord = vec2(color_tex.g + i * scale, 0);
	color_map_val.g = texture2D(my_colortable_texture, color_map_coord).r;

	color_map_coord = vec2(color_tex.r + i * scale, 0);
	color_map_val.r = texture2D(my_colortable_texture, color_map_coord).r;

	//gl_FragColor = color_map_val * my_brightness;
	gl_FragColor = color_map_val;
}
