
#pragma optimize (on)
#pragma debug (off)

#ifndef GL_ARB_texture_rectangle
#error Needs GL_ARB_texture_rectangle
#endif

uniform sampler2DRect my_color_texture;      // = 0
uniform sampler2DRect my_colortable_texture; // = 1

void main()
{
	vec4 color_tex;
	vec2 color_map_coord;
	vec4 color_map_val;

	// Sampling The Texture And Passing It To The Frame Buffer
	color_tex = texture2DRect(my_color_texture, gl_TexCoord[0].st);

	color_tex *= 255.0;
	color_map_coord.y = 0;

	color_map_coord.x = color_tex.b;
	color_map_val.b = texture2DRect(my_colortable_texture, color_map_coord).r;

	color_map_coord.x = color_tex.g + 256.0;
	color_map_val.g = texture2DRect(my_colortable_texture, color_map_coord).r;

	color_map_coord.x = color_tex.r + 512.0;
	color_map_val.r = texture2DRect(my_colortable_texture, color_map_coord).r;

	color_map_val.a   = 1.0;

	gl_FragColor = color_map_val;
}
